clear all; clf; rand('seed',0);
%
npoints=1024*2*4; 		% number of time domain points
n=npoints/2;     		% maximum number of frequencies
nfreq=fix(npoints/10);
junit=sqrt(-1);
%
% frequency axes
fv=[1:32:nfreq]'; Nf=length(fv);
%
[b1,a1]=butter(3,0.07);

fvrel=0.1*fv/nfreq; zet=exp(-sqrt(-1)*2*pi*fvrel);
HLf=(b1(1)+b1(2)*zet+b1(3)*zet.^2+b1(4)*zet.^3)./(a1(1)+a1(2)*zet+a1(3)*zet.^2+a1(4)*zet.^3);
LRf=HLf;
%LRf=ones(Nf,1);
%
figure(1), plot(fvrel,db(HLf)); grid;
%
Xrms=zeros(npoints,1); Xirg=Xrms; Xrphms=Xrms;
%
% xrphms, Xrphms - random phase multisine
 fi=rand(length(fv),1)*2*pi; Zx=exp(-junit*fi); Xrphms=0*Xrphms;
 Xrphms(fv+1)=Zx.*LRf; Xrphms(2*n+1-fv)=conj(Xrphms(1+fv));
 xrphms1=real(ifft(Xrphms)); 
% xrphms=filter(b1,a1,xrphms1);
xrphms=xrphms1;
Axrphms=sqrt(sum(xrphms.^2)/npoints);  xrphms=xrphms/Axrphms;
Xrphms=fft(xrphms); AW=abs(Xrphms)/max(abs(Xrphms));

% xrms, Xrms - random multisine
 fi=rand(length(fv),1)*2*pi; 
 ui=randn(length(fv),1); 
 Zx=exp(-junit*fi).*ui; Xrms=0*Xrms;
 Xrms(fv+1)=Zx.*LRf; Xrms(2*n+1-fv)=conj(Xrms(1+fv));
 xrms1=real(ifft(Xrms)); 
% xrms=filter(b1,a1,xrms1);
xrms=xrms1;
 Axrms=sqrt(sum(xrms.^2)/npoints);  xrms=xrms/Axrms;
 Xrms=fft(xrms);

% xirg, Xirg - ideal filtered Gaussian signal
 xaux=randn(length(xrms),1); Xaux=fft(xaux); Xirg=Xaux.*AW;
 xirg1=real(ifft(Xirg)); 
% xirg1=filter(b1,a1,xaux); 
xirg=xirg1;
Axirg=sqrt(sum(xirg.^2)/npoints); xirg=xirg/Axirg; 
Xirg=fft(xirg);
 
Srms=Xrms.*conj(Xrms); 
Srphms=Xrphms.*conj(Xrphms); 
Sirg=Xirg.*conj(Xirg);

figure(3),
subplot(1,3,2), stem(fv, db(Srms(1+fv)),'o'); %axis([0 900 -10 150]);
xlabel('Random MS','Fontsize',14); grid;
subplot(1,3,1), stem(fv, db(Sirg(1+fv)),'o'); %axis([0 900 -10 150]);
xlabel('Gaussian','Fontsize',14); grid;
subplot(1,3,3), stem(fv, db(Srphms(1+fv)),'o'); %axis([0 900 -10 150]);
xlabel('Random Phase MS','Fontsize',14); grid;
%

